]> git.sesse.net Git - backup.sh/blob - backup.sh
When we run out of disk, do not count that as success.
[backup.sh] / backup.sh
1 #!/bin/bash
2 # backup.sh
3
4 # Backup up Unix-like computers
5
6 # itk@samfundet.no
7 #
8 # This script was first checked into RCS in 2000, and has since backed up a few
9 # servers almost every day, whenever not broken.
10
11 # It's a bit peculiar, but quite effective. The following is worth keeping in
12 # mind when hacking:
13 #
14 # KISS. And by that I mean really simple. Only regular Unix commands, please
15 # (but GNU extensions are used and moreutils has to be installed).
16 #
17 # Because of the way we run this script from cron, informational logging goes
18 # to stderr and warnings and errors to stdout. This way, we get mail whenever
19 # stuff fails, and other output is redirected to the log file.
20
21 # The script is halfway Norwegian and halfway English. Newer modifications are
22 # in English, we should probably stick to that.
23
24 # The computer to backup.
25 computer=$1
26
27 # Configuration
28 LOCKFILE=/home/backup/backuprun.lockfile.$computer
29 confdir=/home/backup/conf/              # Configuration files
30 storagedir=/backup                      # Where we keep backups
31 maksantallfulle=3                       # Number of full backups
32 dagermellomfulle=30                     # Days between full backups
33 dagermellomfulleforfast=32              # Days between full backups for machines with fixed
34                                         # full-backup date (in case the fixed day gets missed)
35 DAY_OF_MONTH=`date "+%d" | sed s/^0//`  # from 1 to 31
36 DATE=`date "+%Y%m%d%H%M"`               #format: touch
37 DATEs=`date "+%Y-%m-%d %H:%M"`          #format: tar
38
39 # Exclude-pattern
40 exclude=$confdir/exclude
41 [ ! -f $exclude ] && printf "tmp\ncore\n" > $exclude
42
43 if [ -z "$computer" ]; then
44         echo "Usage: $0 COMPUTER"
45         exit 1
46 fi
47
48 # Die more or less gracefully (at least notify user)
49 die() {
50         echo `date`": Something nasty happened. Ending, and not deleting lockfile $LOCKFILE."
51         exit 1
52 }
53
54 # Trap C-c and kill
55 trap die SIGINT SIGTERM
56
57 # Don't start if we're already running
58 if [ -e $LOCKFILE ]; then
59         echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting."
60         echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting." >&2
61         exit 1
62 fi;
63 touch $LOCKFILE
64 echo $$ > $LOCKFILE
65
66 echo `date`": Backup run starting" >&2
67
68 umask 027
69
70
71 #selve backupen
72 # krever at noen variabler er satt
73 # krever at vi er i rett katalog
74 backup()
75 {
76
77  echo -n `date` >&2
78  printf " $computer: $computer:$filesystem $backuplevel backup\n" >&2
79
80  if [ "$backuplevel" = "daglig" ] || [ "$backuplevel" = "incremental" ]
81  then
82   lastd=`cat ../.date`
83   lastcmd="--newer='$lastd'"
84  else
85   lastcmd=""
86  fi
87
88  # expand the exclude-path for use with tar
89  exf=`ssh root@$computer "ls ~/.backup/exclude"`
90
91  # We try to run tar on the remote computer
92  #    z gzip it
93  #    c create archive
94  #    C change to directory first
95  #    . where to start taring (see C)
96  #    $lastcmd only files newer than this
97  #    --one-file-system don't traverse file systems
98  #    --exclude-from file to get exclusion pattern from
99  #    Pipe the stuff over ssh to ourselves, run pee to cat the contents to a
100  #    file and build a file list, respectivly.  
101  TARFILE=$DATE.tmp
102  TARCMD="ssh root@$computer \"nice -n 19 ionice -c3 tar --one-file-system -zcf - -C $filesystem . $lastcmd \
103         --exclude-from=$exf\" | pee \"cat > $TARFILE\" \"tar tzvf -\""
104  echo `date`" $computer: Running $TARCMD" >&2
105  eval $TARCMD > $DATE.idx
106
107  if [ $? -eq 0 ] && [ -s $TARFILE ]; then
108   # File is >0 in size and neither cat or tar tzvf failed; we assume it worked.
109
110   # Move tar file in place
111   mv $TARFILE $DATE.tgz
112
113   # Update timestamp
114   echo $DATEs > ../.date && touch -t $DATE ../.date
115
116   # Make a sorted filelist as well
117   sort -k6 < $DATE.idx > $DATE.sdx
118
119   # Fix permissions
120   chmod 600 *tgz                      #only for us
121   chmod 644 *sdx *idx 2>/dev/null     #everyone can read
122
123   # Let the remote computer know that we ran a successful backup (for nagios)
124   ssh root@$computer touch $filesystem/.lastbackup
125
126  else
127   # Something wrong happened.
128   rm $TARFILE
129   echo `date`" $computer: $TARFILE empty. $backuplevel backup of $computer:$filesystem failed and deleted"
130
131   # We don't want to return 0
132   die
133  fi
134
135 }
136
137  # Check that the target filesystem is mounted (actually check that it's not
138  # the root filesystem)
139  if [ ! -d "$storagedir/$computer" ]; then
140         echo `date`" $computer: Target filesystem ($storagedir/$computer) does not exist. Aborting"
141         die
142  fi
143  rootfilesystem=`df -P /`
144  targetfilesystem=`df -P "$storagedir/$computer"`
145  if [ "$rootfilesystem" == "$targetfilesystem" ]; then
146         echo `date`" $computer: Target filesystem ($storagedir/$computer) was mounted on /. Aborting"
147         die
148  fi
149
150  echo `date`" $computer: Backing up $computer" >&2
151
152  # Try to SSH to the computer without entering a password.
153  if ! `ssh -n -o NumberOfPasswordPrompts=0 root@$computer /bin/true`; then
154   echo `date`" $computer: Could not use passwordless SSH."
155
156   # We don't want to return 0
157   die
158  fi
159  
160  filesystems=""
161
162  # Check dump bit in fstab
163  filesystems=`ssh -n root@$computer "cat /etc/fstab" \
164   | grep -v nfs \
165   | grep -v "^#" \
166   | grep -v "^$" \
167   | awk '{ if ( $(NF-1) != "0" ) print $2}' `
168
169  # Clean up our dir at this client
170  if ! ssh root@$computer "rm -r ~/.backup ; mkdir -m 700 ~/.backup"; then
171   echo `date`" $computer: Could not create backup staging area at $computer:~/.backup - skipping backup of $computer"
172   die
173  fi
174
175  # Try to copy $exclude to $computer
176  if ! scp $exclude root@$computer:~/.backup/exclude > /dev/null; then
177   echo `date`" $computer: Could not copy exclude.txt to $computer - skipping backup of $computer"
178   die
179  fi
180
181  # Try to copy preeexec and postexec if they exist
182  if [ -f $confdir/preexec.$computer ]; then
183    if ! scp $confdir/preexec.$computer  root@$computer:~/.backup/preexec >&2; then
184      echo `date`" $computer: Could not copy preexec.$computer to $computer:~/.backup/preexec - skipping backup of $computer"
185      die
186    fi
187  fi
188  if [ -f $confdir/postexec.$computer ]; then
189    if ! scp $confdir/postexec.$computer root@$computer:~/.backup/postexec >&2; then
190      echo `date`" $computer: Could not copy postexec.$computer to $computer:~/.backup/postexec - skipping backup of $computer"
191      die
192    fi
193  fi
194
195  # Try to run preexec if it exist
196  if ! ssh root@$computer "[ ! -f ~/.backup/preexec ] || /bin/bash -x ~/.backup/preexec" >&2; then
197         echo `date`" $computer: Could not run $computer:~/.backup/preexec - skipping backup of $computer"
198         die
199  fi
200
201
202  for filesystem in $filesystems
203  do
204   # Remove / and $ (for Windows) for path names
205   sfilesystem=`echo $filesystem | tr '\/\$' '__'`
206
207   # Prepare storage area
208   mkdir -m 755 -p $storagedir/$computer/$sfilesystem/full 2>/dev/null
209   mkdir -m 755 -p $storagedir/$computer/$sfilesystem/daglig 2>/dev/null
210   echo $filesystem > ${storagedir}/${computer}/.${sfilesystem}.name 
211   chmod 644 ${storagedir}/${computer}/.${sfilesystem}.name
212
213   # Default backuplevel
214   backuplevel=daglig
215
216   if [ ! -f $storagedir/$computer/$sfilesystem/.date ]
217   then
218    # Take the first full backup of this filesystem on this computer
219    backuplevel=full
220    echo $DATEs > $storagedir/$computer/$sfilesystem/.date
221   fi
222
223   # Check if we want a full backup - Debug statement that causes noise in cron mail:
224   # printf " $computer $filesystem: $confdir/fastfullbackupdag.$computer.$sfilesystem\n"
225   if [ -f $confdir/fastfullbackupdag.$computer.$sfilesystem ]; then
226     fullbackup_min_for_this_machine=$dagermellomfulleforfast
227     if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer.$sfilesystem`" ]; then
228       backuplevel=full
229     fi
230   elif [ -f $confdir/fastfullbackupdag.$computer ]; then
231     fullbackup_min_for_this_machine=$dagermellomfulleforfast
232     if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer`" ]; then
233       backuplevel=full
234     fi
235   else
236     fullbackup_min_for_this_machine=$dagermellomfulle 
237   fi
238
239   if [ -z "`find $storagedir/$computer/$sfilesystem/full/ -name \*tgz -mtime -$fullbackup_min_for_this_machine`" ]; then
240    backuplevel=full
241   fi
242
243   # We want to be here
244   cd $storagedir/$computer/$sfilesystem/$backuplevel || die
245
246   # Perform the actual backup
247   backup
248
249   # Check if this box has a custom number of full backups
250   if [ -f $confdir/maksfulle.$computer ] ; then
251     mf=$((`cat $confdir/maksfulle.$computer`+1))
252   else
253     mf=$(($maksantallfulle+1))
254   fi
255
256   # Delete old full backups
257   for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz | tail -n +$mf`
258   do
259    prefix=`echo $full | sed "s/\.[^.]*$//"`
260    echo `date`": $computer:$filesystem Deleting full backup $prefix" >&2
261    rm $prefix*
262   done
263
264   # Delete incremental backups older than the oldest full backup
265   oldf=`ls -t1 $storagedir/$computer/$sfilesystem/full/*tgz | tail -1`
266   find \
267      $storagedir/$computer/$sfilesystem/daglig \
268      -type f \
269      \! -newer $oldf \
270      -printf "`date`: $computer: Deleting old incremental backup: %p\n" \
271      -exec rm {} \; >&2
272  done
273
274  # Try to run postexec if it exist
275  if ! ssh root@$computer "[ ! -f ~/.backup/postexec ] || /bin/bash -x ~/.backup/postexec" >&2; then
276         echo `date`" $computer: Could not run $computer:~/.backup/postexec"
277         die
278  fi
279
280 # Remove lockfile
281 rm $LOCKFILE